// Generated by the DataEntity generator, do not edit
package org.jaccept;

import java.util.*;

import org.jentity.datamodel.visitor.*;
import org.jentity.datamodel.*;

public class TestState extends DataEntity {

	/**
	 * Indicates whether JAccept should supply stimuli to the tests. This is ofcourse \n only possible, if test code has been created, defining the stimuli
	 */
  	public static final TestStateParameter AUTOSTIMULI = new TestStateParameter("autoStimuli");
  	public boolean getAutoStimuli() {
		if (getAttribute(AUTOSTIMULI) != null) {
  			return ((Boolean)getAttribute(AUTOSTIMULI)).booleanValue();
  		} else {
  			return false;
  		}
  	} 
  	public void setAutoStimuli(boolean autoStimuli) {
  		setAttribute(AUTOSTIMULI, new Boolean(autoStimuli));
  	}

	/**
	 * Indicates if JAccept should assert the correctness of the test results to the tests.\n This is ofcourse only possible, if assertion code has been implemented for the test steps
	 */
  	public static final TestStateParameter AUTOASSERTION = new TestStateParameter("autoAssertion");
  	public boolean getAutoAssertion() {
		if (getAttribute(AUTOASSERTION) != null) {
  			return ((Boolean)getAttribute(AUTOASSERTION)).booleanValue();
  		} else {
  			return false;
  		}
  	} 
  	public void setAutoAssertion(boolean autoAssertion) {
  		setAttribute(AUTOASSERTION, new Boolean(autoAssertion));
  	}

	/**
	 * true if JAccept is running in specification mode. Specification mode is used \n to run the test code to create test specification, this means only the documentation \n operations are run.
	 */
  	public static final TestStateParameter SPECIFICATIONMODE = new TestStateParameter("specificationMode");
  	public boolean getSpecificationMode() {
		if (getAttribute(SPECIFICATIONMODE) != null) {
  			return ((Boolean)getAttribute(SPECIFICATIONMODE)).booleanValue();
  		} else {
  			return false;
  		}
  	} 
  	public void setSpecificationMode(boolean specificationMode) {
  		setAttribute(SPECIFICATIONMODE, new Boolean(specificationMode));
  	}

	/**
	 * Indicates whether the test block on test steps. If blocking is enabled some \n other proces needs to continue the test after each test step. This could for example be \n the tester performing the test.
	 */
  	public static final TestStateParameter BLOCKING = new TestStateParameter("blocking");
  	public boolean getBlocking() {
		if (getAttribute(BLOCKING) != null) {
  			return ((Boolean)getAttribute(BLOCKING)).booleanValue();
  		} else {
  			return false;
  		}
  	} 
  	public void setBlocking(boolean blocking) {
  		setAttribute(BLOCKING, new Boolean(blocking));
  	}

	/**
	 * The current step number
	 */
  	public static final TestStateParameter STEPCOUNTER = new TestStateParameter("stepCounter");
  	public int getStepCounter() {
		if (getAttribute(STEPCOUNTER) != null) {
  			return ((Integer)getAttribute(STEPCOUNTER)).intValue();
  		} else {
  			return -1;
  		}
  	} 
  	public void setStepCounter(int stepCounter) {
  		setAttribute(STEPCOUNTER, new Integer(stepCounter));
  	}

	public static class TestStateParameter extends ParameterEnum {
        public TestStateParameter(String name) {
          	super(name);
        }
    }
    
	@SuppressWarnings("unchecked")
    public Class getParameterEnumClass() {
    	return TestStateParameter.class;
    }
    
    @Override
    public DataEntity createInstance() {
    	return new TestState();
    }
    
	private static final Map<TestStateParameter, AttributeVisitor> visitorMap = new HashMap<TestStateParameter, AttributeVisitor>();
    static {    
    	visitorMap.put(AUTOSTIMULI, new DefaultAttributeVisitor ());		
    	visitorMap.put(AUTOASSERTION, new DefaultAttributeVisitor ());		
    	visitorMap.put(SPECIFICATIONMODE, new DefaultAttributeVisitor ());		
    	visitorMap.put(BLOCKING, new DefaultAttributeVisitor ());		
    	visitorMap.put(STEPCOUNTER, new DefaultAttributeVisitor ());		
	}
	
	@Override
	public AttributeVisitor getVisitor(ParameterEnum parameter) {
        return (AttributeVisitor)visitorMap.get(parameter);
    }
	
	//-----------------------------Listener functionality------------------------------------
	private LinkedList<TestStateListener> listeners = new LinkedList<TestStateListener>();
	private final ChangeListener coreListener = new ChangeListener() {
	    public void handleUpdate(ChangeEvent coreChange) {
            TestStateChange changeEvent = new TestStateChange(coreChange);
	        for (Iterator<TestStateListener> iter = listeners.iterator(); iter.hasNext();) {
	            TestStateListener listener = (TestStateListener) iter.next();
	            listener.handleUpdate(changeEvent);
	        }
	    }
	};
	/**
     * Adds a listener to this Entity. Listeners will be notified of changes to
     * the attribute set. 
     */
	@SuppressWarnings("unchecked")
    public void addListener(TestStateListener listener) {
    	if (listeners.size() == 0) {
    		addListener(coreListener);
    	}
    	listeners = (LinkedList<TestStateListener>)listeners.clone();
        listeners.add(listener);
        DataEntity entity = copy();
        listener.handleUpdate(new TestStateChange(new ChangeListener.ChangeEvent(entity, entity, entity)));	
    }
    /**
     * Removes the indicated listener.
     */
	@SuppressWarnings("unchecked")
    public void removeListener(TestStateListener listener) {    
        listeners = (LinkedList<TestStateListener>)listeners.clone();
        listeners.add(listener);
    	if (listeners.size() == 0) {
    		removeListener(coreListener);
    	}
    }
    /**
     * Data core listeners must implement this interface.
     */
    public interface TestStateListener {
        public void handleUpdate(TestStateChange change);
    }
    
    /**
     * Contains information one state change in a data core. 
     */
    public static class TestStateChange {
        private final ChangeListener.ChangeEvent change;
        
        /**
         * Constructs a <code>ChangeEvent</code> object composed of the supplied parameters. 
         */
        private TestStateChange(ChangeListener.ChangeEvent change) {
            this.change = change;
        }
        /**
         * @return Returns the new attribute set applied to the entity.
         */
        public TestState getUpdateValues() {
            return (TestState)change.getUpdateValues();
        }
        /**
         * @return Returns the old attribute set replaced in the update. May be null if 
         * undefined
         */
        public TestState getOldValues() {
            return (TestState)change.getOldValues();
        }
        
        public TestState getModel() {
            return (TestState)change.getModel();
        } 
    }
}

